<?php 
function GetPlugConf() {
	global $configVal;
	requireComponent('Tattertools.Function.misc');
	$data = misc::fetchConfigVal( $configVal);

	$level = $data['Comp_Level'];
	$encoding = $data['Comp_Encoding'];

	if($level && $encoding) return array($encoding, $level);
	else return array(1, 9);
}

function GZipStart() {
	list($encoding, $level) = GetPlugConf();

	if($encoding > 0) {
		ob_start();
		ob_implicit_flush(0);
	}else return 1;
}

function GZipEnd() {
	list($encoding, $level) = GetPlugConf();

	if($encoding > 0) {
		GzDocOut();
		ob_end_flush();
	}else return 1;
}

function CheckCanGzip(){
    global $_SERVER;
    if (headers_sent() || connection_aborted()){
        return 0;
    }
    if (strpos($_SERVER[HTTP_ACCEPT_ENCODING], 'x-gzip') !== false) return "x-gzip";
    if (strpos($_SERVER[HTTP_ACCEPT_ENCODING],'gzip') !== false) return "gzip";
    return 0;
}

function GzDocOut($debug=0){
	list($encoding, $level) = GetPlugConf();

	if($leve == false) $level = 9;
    $ENCODING = CheckCanGzip();

	if($encoding == 2) $ENCODING='gzip';

    if ($ENCODING){
        print "\n<!-- Use compress $ENCODING -->\n";
        $Contents = ob_get_contents();
		$Contents = $Contents;
        ob_end_clean();
        if ($debug){
            $s = "<p>Not compress length: ".strlen($Contents);
            $s .= "<br>Compressed length: ".strlen(gzcompress($Contents,$level));
            $Contents .= $s;
        }
        header("Content-Encoding: $ENCODING");
        print "\x1f\x8b\x08\x00\x00\x00\x00\x00";
        $Size = strlen($Contents);
        $Crc = crc32($Contents);
        $Contents = gzcompress($Contents,$level);
        $Contents = substr($Contents, 0, strlen($Contents) - 4);
        print $Contents;
        print pack('V',$Crc);
        print pack('V',$Size);
    }
}

function CheckZlib() {
	if(!extension_loaded('zlib')) {
		if(!dl('zlib.so')) echo "이 플러그인을 사용할 수 있습니다";
		else echo "이 플러그인을 사용할 수 없습니다";
	}else echo "이 플러그인을 사용할 수 있습니다";
}

function TransferGZip_ko($plugin) {
	global $service;
	
	$manifest = NULL;

	$manifest .= '<?xml version="1.0" encoding="utf-8"?>'.CRLF;
	$manifest .= '<config dataValHandler="">'.CRLF;
	$manifest .= '	<window width="500" height="310" />'.CRLF;
	$manifest .= '		<fieldset legend="원하는 옵션을 선택하세요">'.CRLF;
	$manifest .= '		<field title="압축 수준" name="Comp_Level" type="select">'.CRLF;
	$manifest .= '			<op value="1">1(최저)</op>'.CRLF;
	$manifest .= '			<op value="2">2</op>'.CRLF;
	$manifest .= '			<op value="3">3</op>'.CRLF;
	$manifest .= '			<op value="4">4</op>'.CRLF;
	$manifest .= '			<op value="5">5</op>'.CRLF;
	$manifest .= '			<op value="6">6</op>'.CRLF;
	$manifest .= '			<op value="7">7</op>'.CRLF;
	$manifest .= '			<op value="8">8</op>'.CRLF;
	$manifest .= '			<op value="9" checked="checked">9(최고)</op>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '		<field title="압축 전송" name="Comp_Encoding" type="select">'.CRLF;
	$manifest .= '			<op value="0">사용 안 함</op>'.CRLF;
	$manifest .= '			<op value="1" checked="checked">사용</op>'.CRLF;
	$manifest .= '			<op value="2">무조건 사용</op>'.CRLF;
	$manifest .= '			<caption>'.CRLF;
	$manifest .= '				<![CDATA['.CRLF;
	$manifest .= '				<p><b>사용 안 함</b>: 문서를 전송할 때 압축을 사용하지 않습니다.<br />'.CRLF;
	$manifest .= '				<B>사용</B>: 압축 전송을 지원하는 브라우저만 압축 전송을 사용합니다. 이 값이 기본 값입니다.<br />'.CRLF;
	$manifest .= '				<B>무조건 사용</B>: 브라우저의 압축 전송 가능 여부와 무관하게 무조건 압축 전송합니다..<br />'.CRLF;
	$manifest .= '				<B>무조건 사용</B>을 선택하면 일부 브라우저에서 다운로드 창이 나타날 수 있습니다. 더 자세한 정보는 <A HREF="http://offree.net/notice/465">인쇄 버튼과 압축 전송을 지원합니다</A>라는 글을 읽어보기 바랍니다.'.CRLF;
	$manifest .= '				</p>'.CRLF;
	$manifest .= '				]]>'.CRLF;
	$manifest .= '			</caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '	</fieldset>'.CRLF;
	$manifest .= '</config>';
	
	return $manifest;
}

if(isset($_GET['zlibcheck']))CheckZlib();
?>